package com.fnic.security.jaas;

import java.io.Serializable;
import java.security.Principal;
import java.security.acl.Group;
import java.util.Collections;
import java.util.Enumeration;
import java.util.HashSet;
import java.util.Set;

/**
 * @author suraj
 * Ref: http://stuffthathappens.com/blog/2008/05/16/writing-a-custom-jaas-loginmodule/
 */
public class FNISGroup  implements Group, Serializable {

	private static final long serialVersionUID = 5680455786399918125L;

	private final String name;
	@SuppressWarnings("rawtypes")
	private final Set users = new HashSet();

	public FNISGroup(String name){
		this.name = name;
	}

	@Override
	public String getName() {
		return name;
	}

	@SuppressWarnings("unchecked")
	@Override
	public boolean addMember(Principal user) {
		return users.add(user);
	}

	@Override
	public boolean removeMember(Principal user) {
		return users.remove(user);
	}

	@Override
	public boolean isMember(Principal member) {
		return users.contains(member);
	}

	@SuppressWarnings({ "unchecked", "rawtypes" })
	@Override
	public Enumeration members() {
		return Collections.enumeration(users);
	}

	public boolean equals(Object o){
		if (o == null) return false;

		if (this == o) return true;

		if (! (o instanceof FNISGroup)) return false;

		FNISGroup that = (FNISGroup) o;

		if (this.getName().equals(that.getName())) return true;

		return false;
	}

	public int hashCode() {
		return name.hashCode();
	}
}