package com.fnic.security.jaas.oracle.glassfish;

import java.util.*;

import com.sun.appserv.security.AppservRealm;
import com.sun.enterprise.security.auth.realm.*;
import com.sun.enterprise.security.auth.realm.NoSuchUserException;

import org.apache.log4j.*;

public class FNISRealm extends AppservRealm {
	
	Logger logger = Logger.getLogger(FNISRealm.class);
	
	private Vector<String> appGroups = null;
	private final String authType = "javax.servlet.http.authType";

	public void init(Properties props) throws BadRealmException, NoSuchRealmException
	{
		appGroups = new Vector<String>();
		String groupList = props.getProperty("groups");
		StringTokenizer st = new StringTokenizer(groupList, ", ");
		while (st.hasMoreTokens()) {
			String group = st.nextToken();
			appGroups.add(group);
			logger.debug("FNISRealm.init: Adding group [" + group + "] to realm configuration");
		}
		if (appGroups.isEmpty()) {
			logger.error("FNISRealm.init: The realm configuration is missing the group property identifying the groups supported by the application.");
		} else {
			logger.debug("FNISRealm.init: The realm configuration has " + appGroups.size() + " groups.");
		}
	}
	
	@Override
	public String getAuthType() {
		return authType;
	}

	@Override
	public Enumeration<String> getGroupNames(String arg0)
			throws InvalidOperationException, NoSuchUserException {
		
		return appGroups.elements();
	}

}
